﻿using System;
using System.Collections.Generic;
using System.Text;
using CSIP_42.Model;
using Satsuma;

namespace CSIP_42.Model.Entity
{
    public abstract class Building : Infrastructure, IHaveGate, IGraphNodeID
    {
        /// <summary>
        /// the list of the guests who just waiting out of the game
        /// </summary>
        public Queue<Guest> guests;
        /// <summary>
        /// the list of guests who is on the game (sometimes they just waiting)
        /// </summary>
        public Queue<Guest> queue;

        /// <summary>
        /// the amount of money what the guests pay to the park if they use this building
        /// </summary>
        public int ServicePrice { get { return Identity.ConstructionInformation.TicketPrice; }}

        #region Identified by the Entity Identity - Stored in JSON

        /// <summary>
        /// the amount what the player has to pay every time when the building process start
        /// </summary>
        public int SingleCost { get { return Identity.SingleCost; }}
        /// <summary>
        /// the amount what the player has to pay every second
        /// </summary>
        public int AlwaysCost { get { return Identity.AlwaysCost; }}

        public int TimeToBuild { get { return Identity.TimeToBuild; }  set { Identity.TimeToBuild = value; } }
        public int Capacity { get { return Identity.Capacity; }}
        public int ServiceTime { get { return Identity.ServiceTime; }}
        #endregion

        /// <summary>
        /// the relative coordinate of gate
        /// </summary>
        public Position Gate { get; set; }
        public Node Node { get; set; }
        /// <summary>
        /// the absolut coordinate of gate
        /// </summary>
        public Position GatePosition { get { return position + Gate; } set { Gate = value - position; } }

        public Building(Position pos, EntityIdentifier identifier) : 
                   base(pos, Enumerators.StatusEnum.Building, identifier) 
        {
            guests = new Queue<Guest>();
            queue = new Queue<Guest>();
            this.Gate = identifier.GateVector; 

        }
        


    }
}
