﻿using System;
using System.Collections.Generic;
using System.Text;
using CSIP_42.Model.Enumerators;

namespace CSIP_42.Model.Entity
{
    public abstract class Entity
    {
        public EntityIdentifier Identity;

        public Position position;
        public StatusEnum status; 

        public Entity(Position _position, StatusEnum _status, EntityIdentifier _identity)
        {
            Identity = new EntityIdentifier(_identity);
            position = _position;
            status = _status;
        }

        public CategoryEnum Category 
        { 
            get 
            { 
                return Identity.Category; 
            } 
            private set 
            {
                throw new InvalidOperationException("You cannot change an Entity's Category once is constructed"); 
            } 
        }
        public TypeNameEnum Type 
        { 
            get 
            { 
                return Identity.Type; 
            } 
            private set 
            {
                throw new InvalidOperationException("You cannot change an Entity's Type once is constructed");
            } 
        }
    }
}
