﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Timers;

namespace CSIP_42.Model.Entity
{
    public abstract class Game : Building
    {

        /// <summary>
        /// the amount by which the "happiness" level of the guest increases
        /// </summary>
        public int HappinessModifier { get { return Identity.HappinessModifier; }} 

        public int MinCapacity { get { return Identity.ConstructionInformation.MinimumCapacity; }}
        public int usageLevel;
        public bool hasElectricity; 
        public int serviceTimeRemaining;
        public int repairTimeRemaining;
        public Mechanic mechanic;

        public Game(Position pos, EntityIdentifier identifier) 
             : base(pos, identifier)
        {
            hasElectricity = true; 
            serviceTimeRemaining = 0;
            repairTimeRemaining = 0;
            mechanic = null;
            usageLevel = 100;
        }
    }
}
