﻿using System;
using System.Collections.Generic;
using System.Text;
using Satsuma;
using CSIP_42.Model.Enumerators;

namespace CSIP_42.Model.Entity
{
    public abstract class Person : Entity
    {
        
        public PersonPlaceEnum place;
        public Path pathToTarget; 
        protected Infrastructure[,] map;

        #region FUNCTIONS

        public Person(Infrastructure[,] map, Position pos, StatusEnum st, EntityIdentifier identifier): base(pos,st, identifier)
        {
            this.map = map;
            place = PersonPlaceEnum.OnRoad;
        }

        /// <summary>
        /// Set the path what the person will follow
        /// </summary>
        /// <param name="path">The Path</param>
        public void SetPath(Path path) { pathToTarget = path; }
        public abstract bool Move();
        /// <summary>
        /// Get the category of where the person wants to go
        /// </summary>
        /// <returns>Category of element (Road | Game | Toalett | Restaurant | Main Gate)</returns>
        public virtual CategoryEnum WhatWant() { return CategoryEnum.Road; } 
        #endregion
    }
}
