﻿using System;
using System.Collections.Generic;
using System.Text;
using CSIP_42.Model.Entity;
using CSIP_42.Model.Enumerators;
using Satsuma;

namespace CSIP_42.Model
{
    public class GameObject
    {
        #region Fields
        public MainGate mainGate;
        #endregion


        public GameObject(int sizeN, int sizeM, EntityIdentifier mainGateIdentifier, long money = 150000, bool open = false, CustomGraph graph = null)
        {
            this.SizeN = sizeN;
            this.SizeM = sizeM;
            this.Money = money;
            this.Open = open;
            this.Graph = graph;
            if (graph == null)
            {
                this.Graph = new CustomGraph();
            }

            Table = new Infrastructure[sizeN, sizeM];
            for (int i = 0; i < sizeN; i++)
            {
                for (int j = 0; j < sizeM; j++)
                {
                    Table[i, j] = null;
                }
            }

            Infrastructures = new Dictionary<CategoryEnum, List<Infrastructure>>();
            CategoryEnum[] categories = (CategoryEnum[])Enum.GetValues(typeof(CategoryEnum));
            foreach (var category in categories)
            {
                Infrastructures.Add(category, new List<Infrastructure>());
            }

            People = new Dictionary<TypeNameEnum, List<Person>>
            {
                { TypeNameEnum.Cleaner, new List<Person>() },
                { TypeNameEnum.Guest, new List<Person>() },
                { TypeNameEnum.Mechanic, new List<Person>() }
            };


        }



        #region Properties
        public int SizeN { get;  set; }
        public int SizeM { get;  set; }
        public long Money { get;  set; }
        public Infrastructure[,] Table { get;  set; }
        public Dictionary<CategoryEnum, List<Infrastructure>> Infrastructures { get;  set; }
        public bool Open { get;  set; }
        public Dictionary<TypeNameEnum, List<Person>> People { get;  set; }
        public Satsuma.CustomGraph Graph { get;  set; } 
        public Position MainGatePos { get { return mainGate.position; }}
        #endregion

        
    }
}
