﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Windows;
using System.Windows.Input; // MouseEventArgs, AssociatedObject
using Microsoft.Xaml.Behaviors;

// src: https://stackoverflow.com/questions/8360209/how-to-add-system-windows-interactivity-to-project/65701484#65701484
// igy valtozott: https://devblogs.microsoft.com/dotnet/open-sourcing-xaml-behaviors-for-wpf/
namespace CSIP_42.View.Behaviours
{
    // src: https://stackoverflow.com/questions/30047415/how-do-i-get-mouse-positions-in-my-view-model
    public class MouseBehaviour : Microsoft.Xaml.Behaviors.Behavior<FrameworkElement>
    {
        public static readonly DependencyProperty MouseYProperty = DependencyProperty.Register(
            "MouseY", typeof(double), typeof(MouseBehaviour), new PropertyMetadata(default(double)));

        public double MouseY
        {
            get { return (double)GetValue(MouseYProperty); }
            set { SetValue(MouseYProperty, value); }
        }

        public static readonly DependencyProperty MouseXProperty = DependencyProperty.Register(
            "MouseX", typeof(double), typeof(MouseBehaviour), new PropertyMetadata(default(double)));

        public double MouseX
        {
            get { return (double)GetValue(MouseXProperty); }
            set { SetValue(MouseXProperty, value); }
        }

        protected override void OnAttached()
        {
            AssociatedObject.MouseMove += AssociatedObjectOnMouseMove;
        }

        private void AssociatedObjectOnMouseMove(object sender, MouseEventArgs mouseEventArgs)
        {
            var pos = mouseEventArgs.GetPosition(AssociatedObject);
            MouseX = pos.X;
            MouseY = pos.Y;
        }

        protected override void OnDetaching()
        {
            AssociatedObject.MouseMove -= AssociatedObjectOnMouseMove;
        }
    }
}
